import doorman.options as options
from . import storage_encapsulation
from .classes import CsvStorage, JsonStorage

if options.storage_encrypt == True:
    encapsulation_class = storage_encapsulation.DESFileEncapsulation
else:
    encapsulation_class = storage_encapsulation.RawFileEncapsulation

if options.storage == 'json':
    encapsulation = encapsulation_class(options.json)
    storage = JsonStorage(encapsulation)
if options.storage == 'csv':
    encapsulation = encapsulation_class(options.csv)
    storage = CsvStorage(encapsulation)

nobody = (None, '-unknown-')

get_card = lambda h: storage.get(h, nobody)
cards_for_user = lambda name: [k_v1[0] for k_v1 in [k_u_n for k_u_n in iter(storage.items()) if k_u_n[1][1] == name]]

def add_user(username, hash, uid):
    storage[hash] = (uid, username)

def del_card(hash):
    return storage.pop(hash, nobody)

def del_filter(f):
    cards = [k_v[0] for k_v in list(filter(f, iter(storage.items())))]
    r = []
    for c in cards:
        r.append(storage.pop(c, nobody))
    return r

del_uid = lambda uid: del_filter(lambda k_u_n2: k_u_n2[1][0] == uid)
del_username = lambda name: del_filter(lambda k_u_n3: k_u_n3[1][1] == name)
